import { type Config } from '@pnpm/config';
import { type RunLifecycleHookOptions } from '@pnpm/lifecycle';
import { type ProjectManifest } from '@pnpm/types';
import { type PublishRecursiveOpts } from './recursivePublish';
export declare function rcOptionsTypes(): Pick<any, never>;
export declare function cliOptionsTypes(): {
    'dry-run': BooleanConstructor;
    force: BooleanConstructor;
    json: BooleanConstructor;
    recursive: BooleanConstructor;
    'report-summary': BooleanConstructor;
};
export declare const commandNames: string[];
export declare function help(): string;
export declare function handler(opts: Omit<PublishRecursiveOpts, 'workspaceDir'> & {
    argv: {
        original: string[];
    };
    engineStrict?: boolean;
    recursive?: boolean;
    workspaceDir?: string;
} & Pick<Config, 'allProjects' | 'gitChecks' | 'ignoreScripts' | 'publishBranch' | 'embedReadme'>, params: string[]): Promise<{
    exitCode: number;
    manifest?: undefined;
} | undefined>;
export declare function publish(opts: Omit<PublishRecursiveOpts, 'workspaceDir'> & {
    argv: {
        original: string[];
    };
    engineStrict?: boolean;
    recursive?: boolean;
    workspaceDir?: string;
} & Pick<Config, 'allProjects' | 'gitChecks' | 'ignoreScripts' | 'publishBranch' | 'embedReadme' | 'packGzipLevel'>, params: string[]): Promise<{
    exitCode: number;
    manifest?: undefined;
} | {
    manifest: ProjectManifest;
    exitCode?: undefined;
}>;
export declare function runScriptsIfPresent(opts: RunLifecycleHookOptions, scriptNames: string[], manifest: ProjectManifest): Promise<void>;
